import math;
import hyperbolic_geometry;

size(500,500);
settings.outformat="pdf";

hyperbolic_point O = hyperbolic_point(0,0);


//hyperbolic_point A = hyperbolic_point(0.25,30);
//hyperbolic_point B = hyperbolic_point(0.25,150);

hyperbolic_point A = hyperbolic_point(0.5,40);
hyperbolic_point B = hyperbolic_point(0.5,100);

//hyperbolic_point A = hyperbolic_point(0.25,0);
//hyperbolic_point B = hyperbolic_point(0.25,180);

hyperbolic_point M = midpoint(A,B);

hyperbolic_line L = hyperbolic_line(A,B);
draw(L, black);

hyperbolic_circle C = hyperbolic_circle(M,A);
draw(C, blue);

hyperbolic_line N;
hyperbolic_line X;

hyperbolic_point E = A;
for(int i = 0; i < 10; ++i) {
    N = hyperbolic_normal(L, E);
    C = mirror(N, C);
    X = hyperbolic_normal(L, C.get_centerpoint());
    E = mirror(X, E);
    draw(N, orange);
    draw(C, blue);
}

hyperbolic_circle C = hyperbolic_circle(M,B);
hyperbolic_point E = B;
for(int i = 0; i < 10; ++i) {
    N = hyperbolic_normal(L, E);
    C = mirror(N, C);
    X = hyperbolic_normal(L, C.get_centerpoint());
    E = mirror(X, E);
    draw(N, orange);
    draw(C, blue);
}

hyperbolic_circle C = hyperbolic_circle(M,B);
hyperbolic_line K = hyperbolic_normal(L, O);
hyperbolic_point[] I = intersection(C, K);
hyperbolic_line L1 = hyperbolic_normal(K, I[0]);
hyperbolic_line L2= hyperbolic_normal(K, I[1]);

draw(L1, gray);
draw(L2, gray);

draw((1,1)--(1,-1)--(-1,-1)--(-1,1)--cycle);
draw(unitcircle);
